;###############################################################################
/* Gui for LilBuilder

*/
;###############################################################################

Gui_Create() {
  local GuiHWND
  static GuiCnt = 9     ;start user guis with id 10, which leave 9 guis for the builder

  GuiCnt++
  Gui, %GuiCnt%:+LastFound +Resize +LabelGui_
  GuiHWND := WinExist() + 0
  WinSet, Trans, 255, ahk_id %GuiHWND%
  WinSet, Trans, 255
  Gui, %GuiCnt%:Show, w550 h610, %ScriptName% - r%SVN_RevNum% %SVN_RevDate%
;   Gui, %GuiCnt%:Add,Picture, x0 y0 vGrid%GuiHWND%, res\grid.gif
  Gui(GuiHWND,"Create")
  Gui(GuiHWND,"Resize", 1)
  Gui(GuiHWND,"GuiID", GuiCnt)
  Project_AddUserGUI(GuiHWND)
  Selector_SelGuiHWND(GuiHWND)
}

Gui_Close:
  ExitApp
return

Gui_Refresh:
  DllCall("InvalidateRect", "uint", Selector_SelGuiHWND(), "uint", 0, "uint", 0)
  DllCall("UpdateWindow", "uint", Selector_SelGuiHWND())
  Grid_Draw()
  Tooltip, here
return

Gui_Size:
  Grid_Draw()
Return

Gui_AddControl(GuiHWND,CtrlHWND){
  Control(CtrlHWND,"BelongsTo", GuiHWND)
  OrderOfControls := Gui(GuiHWND,"OrderOfControls") "," CtrlHWND
  Gui(GuiHWND,"OrderOfControls",OrderOfControls)
}
Gui_RemoveControl(CtrlHWND){
  HWND := Control(CtrlHWND,"BelongsTo")  ;check to which item it belongs (gui or tab page)
  If InStr(HWND, "T") {                           ;it's a tab page control
    OrderOfControls := Control(HWND,"OrderOfControls") ","     ;remove it from tab page control list
    CtrlHWND = ,%CtrlHWND%,
    StringReplace, OrderOfControls, OrderOfControls, CtrlHWND, `,
    StringTrimRight, OrderOfControls, OrderOfControls, 1
    Control(HWND,"OrderOfControls",OrderOfControls)
  }
  Else {
    OrderOfControls := Gui(HWND,"OrderOfControls") ","         ;remove it from gui control list
    CtrlHWND = ,%CtrlHWND%,
    StringReplace, OrderOfControls, OrderOfControls, CtrlHWND, `,
    StringTrimRight, OrderOfControls, OrderOfControls, 1
    Gui(HWND,"OrderOfControls",OrderOfControls)
  }
}

; Gui_GetListOfAllControls(GuiHWND){
;   OrderOfControls := Gui(GuiHWND,"OrderOfControls")
;   Loop, Parse, OrderOfControls, `,
;     {
;       If !A_LoopField
;         Continue
;       ListOfAllControls .= "|" A_LoopField
;       If ("Tab" = Control(A_LoopField,"Type"){
;         TabHWND := A_LoopField
;         TabPages := Control(TabHWND,"Content")
;         Loop, Parse, TabPages, |
;         {
;           TabControls := Control(TabHWND "T" A_Index,"OrderOfControls")
;         }
;       }
;     }  
; }

;return a list of all controls on that gui, including tab page controls
Gui_GetListOfAllControls(GuiHWND){
  OrderOfControls := Gui(GuiHWND,"OrderOfControls")
  Loop, Parse, OrderOfControls, `,
    {
      If !A_LoopField
        Continue
      ListOfAllControls .= Gui_GetListOfAllControls_CheckForTab(A_LoopField)
    }
  StringTrimLeft, ListOfAllControls, ListOfAllControls, 1
  Return ListOfAllControls  
}
Gui_GetListOfAllControls_CheckForTab(CtrlHWND){
  If ("Tab" <> Control(CtrlHWND,"Type"))
    Return "|" CtrlHWND

  AllTabControls := CtrlHWND
  TabPages := Control(CtrlHWND,"Content")
  Loop, Parse, TabPages, |
  {
    TabControls := Control(CtrlHWND "T" A_Index,"OrderOfControls")
    Loop, Parse, TabControls, `,
      {
        If !A_LoopField
          Continue
        AllTabControls .= Gui_GetListOfAllControls_CheckForTab(A_LoopField)  ;recurse into tab page controls
      }  
  }
  Return "|" AllTabControls
}




Gui(HWND,PropertyNameOrAction,Value=""){
  Static MasterDic, init = 0

  If !init {  ;set up a master dic once to link HWNDs to their pDic
    init++
    MasterDic := Dic("insensitive")
  }

  If (HWND = "Remove" And PropertyNameOrAction = "All")  ;delete all dics
  {
    Loop{                                                ;delete all Gui dics
      If (HWND := Dic_NextKey(penum, MasterDic))
        Dic("delete", Dic_Get(MasterDic, HWND))
      If !penum
        Break
    }
    Dic("delete",MasterDic)                              ;delete master dic
    init = 0                                             ;reset init state
  }

  Else If PropertyNameOrAction = Remove   ;remove dic for Gui
  {
    Dic("delete", Dic_Get(MasterDic, HWND))    ;delete the dic for the Gui
    Dic_Remove(MasterDic, HWND)                ;remove dic from master dic
  }

  Else If PropertyNameOrAction = Create  ;create a dic for Gui
  { ;store pDic of dic in master list under the HWND key
    Dic_Set(MasterDic, HWND, Dic("insensitive"))
  }

  Else If Value   ;assign value
  { ;get pDic from master dic and assign value
    Dic_Set(Dic_Get(MasterDic, HWND), PropertyNameOrAction, Value)
  }

  Else ;return value
  { ;get pDic from master dic and return value
    Return Dic_Get(Dic_Get(MasterDic, HWND), PropertyNameOrAction)
  }
  Return 1
}
