;###############################################################################
/* Messages for LilBuilder

*/
;###############################################################################

Messages_SetHandlers( pFlag ) {
  static WM_LBUTTONDOWN   := 0x201
       , WM_LBUTTONUP     := 0x202
       , WM_LBUTTONDBLCLK := 0x203
       , WM_RBUTTONDOWN   := 0x204
       , WM_RBUTTONUP     := 0x205
       , WM_RBUTTONDBLCLK := 0x206
       , WM_MBUTTONDOWN   := 0x207
       , WM_MBUTTONUP     := 0x208
       , WM_MBUTTONDBLCLK := 0x209
       , WM_MOUSEWHEEL    := 0x20A
       , WM_MOUSEMOVE     := 0x200
       , WM_SYSCOMMAND    := 0x112
       , WM_PAINT         := 0x0F


  If pFlag {
    OnMessage(WM_LBUTTONDOWN,     "Messages_OnLButtonDown")
    OnMessage(WM_LBUTTONUP,       "Messages_OnLButtonUp")
    OnMessage(WM_LBUTTONDBLCLK,   "Messages_OnLButtonDBLCLK")
    OnMessage(WM_RBUTTONDOWN,     "Messages_OnRButtonDown")
    OnMessage(WM_RBUTTONUP,       "Messages_OnRButtonUp")
    OnMessage(WM_RBUTTONDBLCLK,   "Messages_OnRButtonDBLCLK")
    OnMessage(WM_MBUTTONDOWN,     "Messages_OnMButtonDown")
    OnMessage(WM_MBUTTONUP,       "Messages_OnMButtonUp")
    OnMessage(WM_MBUTTONDBLCLK,   "Messages_OnMButtonDBLCLK")
    OnMessage(WM_MOUSEWHEEL,      "Messages_OnMouseWheel")
    OnMessage(WM_MOUSEMOVE,       "Messages_OnMouseMove")
    OnMessage(WM_SYSCOMMAND,      "Messages_OnSysCommand")
    OnMessage(WM_PAINT,           "Messages_OnPaint")
  } Else {
    OnMessage(WM_LBUTTONDOWN,     "")
    OnMessage(WM_LBUTTONUP,       "")
    OnMessage(WM_LBUTTONDBLCLK,   "")
    OnMessage(WM_RBUTTONDOWN,     "")
    OnMessage(WM_RBUTTONUP,       "")
    OnMessage(WM_RBUTTONDBLCLK,   "")
    OnMessage(WM_MBUTTONDOWN,     "")
    OnMessage(WM_MBUTTONUP,       "")
    OnMessage(WM_MBUTTONDBLCLK,   "")
    OnMessage(WM_MOUSEWHEEL,      "")
    OnMessage(WM_MOUSEMOVE,       "")
    OnMessage(WM_SYSCOMMAND,      "")
    OnMessage(WM_PAINT,           "")
  }
}

Messages_OnLButtonDown(wparam, lparam, msg, hwnd){
   ha := 0 + DllCall("GetAncestor", "uint", hwnd, "uint", 2)      ;get gui handle [ GA_ROOT ]
   if Project_IsUserGUI(ha) {
      Selector_SelGuiHwnd(ha)
      MouseGetPos, mX,mY,, hCtrl, 2
      If hCtrl {
         CtrlHwnd := 0 + TopChild(ha, 0 + hCtrl)
         If GetKeyState("LControl") {
           Selector_AddCtrlToSelection(CtrlHwnd)
         }Else{
           Selector_SelMultiHWND("No")                    ;clean multiselection
           Selector_SelCtrlHwnd(CtrlHwnd)
           Selector_Set2Ctrl()
         }
      }
      Else{
         Selector_Size("-")
         Selector_Hide()
         Selector_IsDrawingFrame(True)
         Selector_SelCtrlHwnd("No")                       ;clean single selection
         Selector_SelMultiHWND("No")                      ;clean multi selection
         Selector_DrawFrame(mX, mY)
      }
      return 0
   }
}
TopChild(pParent, h) {
   loop {
      hp := 0 + DllCall("GetParent", "uint", h)
      if (hp=pParent) or !hp
         return h
      h := hp
   }
}

Messages_OnLButtonUp(wparam, lparam, msg, hwnd){
  If Selector_IsDrawingFrame() {
    Selector_IsDrawingFrame(False)
    Selector_DrawFrame("", "", "End")
    Selector_SelectByBox()                   ;select controls based on frame pos/size
    If Selector_SelCtrlHWND()                ;update selector to new single selection
      Selector_Set2Ctrl()
    Else If Selector_SelMultiHWND()          ;update selector to new multi selection
      Selector_Set2MultiSel()
    Else
      Selector_Hide()
    Selector_Size("+")
  }
}

; Messages_OnLButtonDBLCLK(wparam, lparam, msg, hwnd){
;      ;??? nothing yet
; }

Messages_OnRButtonDown(wparam, lparam, msg, hwnd){
  MouseGetPos, X, Y, GuiHWND, CtrlHWND, 2
  Menu_X(X)
  Menu_Y(Y)
  if (hwnd = Selector_HWND()){
    Menu_SelGuiHWND(Selector_SelGuiHwnd())
    If Selector_SelMultiHWND()
      GoSub, MultiSelection_ShowMenu
    Else {
      Menu_SelCtrlHWND(Selector_SelCtrlHwnd())
      Messages_ShowMenu(Selector_SelCtrlHwnd())
    }
  }
  Else If Project_IsUserGUI(0 + GuiHWND){
    Selector_SelMultiHWND("No")
    Selector_SelCtrlHWND("No")
    Menu_SelGuiHWND(GuiHWND + 0)
    If CtrlHWND {
        CtrlHwnd := 0 + TopChild(GuiHWND, 0 + CtrlHWND)
        Menu_SelCtrlHWND(CtrlHWND)
        Messages_ShowMenu(CtrlHWND)
    }
    Else
        GoSub, Gui_ShowMenu
  }
  Else If (hwnd = Toolbox_HWND()){
     ;??? nothing yet
  }
}

Messages_ShowMenu(CtrlHWND){
  If !(Type := Control(CtrlHWND, "Type"))
    Return
  Label = %Type%_ShowMenu
  If IsLabel(Label)
      GoSub, %Label%
}

; Messages_OnRButtonUp(wparam, lparam, msg, hwnd){
;      ;??? nothing yet
; }
;
; Messages_OnRButtonDBLCLK(wparam, lparam, msg, hwnd){
;      ;??? nothing yet
; }
;
; Messages_OnMButtonDown(wparam, lparam, msg, hwnd){
;      ;??? nothing yet
; }
;
; Messages_OnMButtonUp(wparam, lparam, msg, hwnd){
;      ;??? nothing yet
; }
;
; Messages_OnMButtonDBLCLK(wparam, lparam, msg, hwnd){
;      ;??? nothing yet
; }
;
; Messages_OnMouseWheel(wparam, lparam, msg, hwnd){
;      ;??? nothing yet
; }

Messages_OnMouseMove(wparam, lparam, msg, hwnd) {
  If Selector_IsDrawingFrame()
    Selector_DrawFrame()
  Else if (hwnd = Selector_HWND() and GetKeyState("LButton")){
    SendMessage, 0x112,0xF012,0,,% "ahk_id " hwnd ; [ WM_SYSCOMMAND, SC_MOVE ]

    If (GRID() AND !GetKeyState("LControl")){     ;when GRID
      If Selector_SelCtrlHWND(){                       ;when single selection 
        Selector_UpdateCtrlwGrid("PositionOnly")            ;update control to new grid position
        GoSub, Selector_UpdateItself                        ;update selector pos to new control position
      }
      Else If Selector_SelMultiHWND(){                 ;when multi selection
        Selector_Pos2Grid()                                 ;snap selector pos to grid
        Selector_UpdateCtrl()                               ;update controls to new selector position
      }
    }                                             ;when NOT grid
    else Selector_UpdateCtrl()                         ;update controls to new selector position
  }
}

; Messages_OnSysCommand(wparam, lparam, msg, hwnd){
;      ;??? nothing yet
; }
;
; Messages_OnPaint(wparam, lparam, msg, hwnd){
;      ;??? nothing yet
; }

