;###############################################################################
/* Tab for LilBuilder

*/
;###############################################################################

Tab_CreateMenu(Menu_Tab, Menu_TabPages){
  MMenu_Add(Menu_Tab, "Add page","","","iTab_AddPage")
  MMenu_Add(Menu_Tab, "Rename page","","","iTab_RenamePage")
  MMenu_Add(Menu_Tab, "Select page","","","m" Menu_TabPages)
  MMenu_Add(Menu_Tab, "Delete last page","","","iTab_DeleteLastPage")
  MMenu_Add(Menu_Tab)
  MMenu_Add(Menu_Tab, "Add new controls to this page","","","iTab_AddNewControlsToPage")
}

Tab_ShowMenu:
  Tab_FillTabPageSubMenu(Menu_TabPages)
  Tab_UpdateaddToTabMenu(Menu_Tab, Menu_SelGuiHWND(), Menu_SelCtrlHWND())
  MMenu_Show(Menu_Tab, Menu_X(), Menu_Y(), "Tab_OnSelection")
Return

Tab_OnSelection:
  If MMenu_ID = Tab_AddPage
    Tab_AddPage(Menu_SelGuiHWND(), Menu_SelCtrlHWND())
  Else If MMenu_ID = Tab_RenamePage
    Tab_RenamePage(Menu_SelGuiHWND(), Menu_SelCtrlHWND())
  Else If MMenu_ID = Tab_DeleteLastPage
    Tab_DeleteLastPage(Menu_SelGuiHWND(), Menu_SelCtrlHWND())
  Else If MMenu_ID = Tab_AddNewControlsToPage
    Tab_AddNewControlsToPage(Menu_SelGuiHWND(), Menu_SelCtrlHWND())
  Else If InStr(MMenu_ID, "Tab_SelectPage_")
    Tab_SelectPage(Menu_SelGuiHWND(), Menu_SelCtrlHWND(), MMenu_ID)
Return

;###############################################################################

Tab_AddPage(GuiHWND, CtrlHWND) {
  Content := Control(CtrlHWND, "Content")
  StringReplace, x, Content, |, , UseErrorLevel
  TabCnt := ErrorLevel + 2
  TabID := Control(CtrlHWND,"TabID",TabID)
  Content .= "|Tab" TabID "." TabCnt

  GuiID := Gui(GuiHWND, "GuiID")
  CtrlID := Control(CtrlHWND, "VarName")
  GuiControl, %GuiID%:, %CtrlID%, |%Content%

  ;update property
  Control(CtrlHWND, "Content", Content)

  ;add tab page subcontrol, if not already present
  If !Control(CtrlHWND "T" TabCnt,"Type") {
    Control(CtrlHWND "T" TabCnt,"Create")
    Control(CtrlHWND "T" TabCnt,"Type","TabPage")
  }
}

Tab_AddControl2Page(TabPageHWND, CtrlHWND){
  Control(CtrlHWND,"BelongsTo", TabPageHWND)
  OrderOfControls := Control(TabPageHWND,"OrderOfControls") "," CtrlHWND
  Control(TabPageHWND,"OrderOfControls",OrderOfControls)
}

Tab_RenamePage(GuiHWND, CtrlHWND){
  GuiID := Gui(GuiHWND, "GuiID")
  CtrlID := Control(CtrlHWND, "VarName")
  GuiControlGet, ActivePage, %GuiID%:, %CtrlID%

  Content := Control(CtrlHWND, "Content")
  StringSplit, Content, Content, |
  CurrentName := Content%ActivePage%

  InputBox, NewName, Rename Tab Page, Specify an new Name, , , , Menu_X(), Menu_Y(), , , % Content%ActivePage%
  If (NewName AND NewName <> Content%ActivePage%){
    Content =
    Loop, %Content0%{
      If (A_Index = ActivePage)
        Content .= "|" NewName
      Else
        Content .= "|" Content%A_Index%
    }
    GuiControl, %GuiID%:, %CtrlID%, %Content%
    GuiControl, %GuiID%:Choose, %CtrlID%, %ActivePage%
    StringTrimLeft, Content, Content, 1
    ;update property
    Control(CtrlHWND, "Content", Content)
  }
}

Tab_DeleteLastPage(GuiHWND, CtrlHWND){
  Content := Control(CtrlHWND, "Content")
  If (Pos := InStr(Content, "|","",0)) {   ;can't remove last tab page
    StringLeft, Content, Content, % Pos - 1

    GuiID := Gui(GuiHWND, "GuiID")
    CtrlID := Control(CtrlHWND, "VarName")
    GuiControl, %GuiID%:, %CtrlID%, |%Content%

    ;update property
    Control(CtrlHWND, "Content", Content)
  }
}

Tab_AddCtrl2Page(NewHWND=""){   ;HWND of tab page subcontrol
  static HWND
  If NewHWND = No
     HWND =
  Else If NewHWND
     HWND = %NewHWND%
  Return %HWND%
}

Tab_AddNewControlsToPage(GuiHWND, CtrlHWND = ""){
  GuiID := Gui(GuiHWND, "GuiID")
  CtrlID := Control(CtrlHWND, "VarName")
  GuiControlGet, ActivePage, %GuiID%:, %CtrlID%
  NewTabPage := CtrlHWND "T" ActivePage
  If (!CtrlHWND OR NewTabPage = Tab_AddCtrl2Page()){
    Tab_AddCtrl2Page("No")
    Gui, %GuiID%:Tab
  }
  Else {
    Tab_AddCtrl2Page(NewTabPage)
    TabID := Control(CtrlHWND,"TabID")
    Gui, %GuiID%:Tab,%ActivePage%,%TabID%
  }
}

Tab_UpdateaddToTabMenu(Menu_Tab, GuiHWND, CtrlHWND){
  GuiID := Gui(GuiHWND, "GuiID")
  CtrlID := Control(CtrlHWND, "VarName")
  GuiControlGet, ActivePage, %GuiID%:, %CtrlID%

  SelTabPage := CtrlHWND "T" ActivePage
  CheckStatus := SelTabPage = Tab_AddCtrl2Page() ? "+c" : "-c"
  MMenu_Set(Menu_Tab,"Tab_AddNewControlsToPage","","",CheckStatus )
}

Tab_FillTabPageSubMenu(Menu_TabPages){
  CtrlHWND := Menu_SelCtrlHWND()
  Content := Control(CtrlHWND, "Content")
  MMenu_RemoveAll(Menu_TabPages)
  Loop, Parse, Content, |
      MMenu_Add(Menu_TabPages, A_LoopField,"","","iTab_SelectPage_" A_Index)
}

Tab_SelectPage(GuiHWND, CtrlHWND, MMenu_ID){
  StringReplace, Tab2Sel, MMenu_ID, Tab_SelectPage_
  GuiID := Gui(GuiHWND, "GuiID")
  CtrlID := Control(CtrlHWND, "VarName")
  GuiControl, %GuiID%:Choose, %CtrlID%, %Tab2Sel%

  ;switch to add controls to tab page when tab page get switched
  If Tab_AddCtrl2Page()
    Tab_AddNewControlsToPage(GuiHWND)

  ;update property
  Control(CtrlHWND, "Content", Content)
}
